#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include <unistd.h>
#include <gccore.h>
#include <gctypes.h>
#include <wiiuse/wpad.h>
#include <ogc/isfs.h>
#include <debug.h>

#include "certs_bin.h"
#include "tmd_bin.h"
#include "ticket_bin.h"
#include "patch.h"
#include "patches.h"

static void *xfb = NULL;
static GXRModeObj *rmode = NULL;
s32 ret, fd;
u32 len;
void *buffer;
const char *filename = "/title/00000001/00000002/content/00000070.app";
const char *filename1 = "/title/00000001/00000002/content/10000070.app";
const char *err = "Error: %d.\n\n";
//Wiicrazy __CODE
//-----------------------------------------------------------------------------------------------------------
s32 HEDE_OpenContent(u16 index) 
{
    s32 fd;
	
	if (index==0) {
	fd	= ISFS_Open(filename1, (u8)ISFS_OPEN_READ);
	//printf(err, fd);
		return fd; 	
	} else {
	fd	= ISFS_Open(filename, (u8)ISFS_OPEN_READ);
	//printf(err, fd);
		return fd; 	
	}
}

s32 HEDE_OpenContentWRITE(u16 index) 
{
    s32 fd;
	
	if (index==0) {
	fd = ISFS_Open(filename1, (u8)ISFS_OPEN_WRITE);
	//printf(err, fd);
		return fd; 	
	} else {
	fd = ISFS_Open(filename, (u8)ISFS_OPEN_WRITE);
	//printf(err, fd);
		return fd; 	
	}
}
//--------------------------------------------------------------------------------------------------------------

int load_menu() {
	printf("ES_Init...");
	ret = __ES_Init();
	if (ret < 0) {
		printf(err, ret);
		return ret;
	}
	printf("Done!\n\nES_Identify (as SU)...");
	ret = ES_Identify((signed_blob *)certs_bin, certs_bin_size, (signed_blob *)tmd_bin, tmd_bin_size, (signed_blob *)ticket_bin, ticket_bin_size, NULL);
	if (ret < 0) {
		printf(err, ret);
		return ret;
	}
	printf("Done!\n\nISFS_Initialize...");
	ret = ISFS_Initialize();
	if (ret < 0) {
		printf(err, ret);
		return ret;
	}
	printf("Done!\n\nISFS_Open...");
   fd = HEDE_OpenContent(index);
	if(fd ==NULL) {
		printf(err, fd);
		return fd;
	}
	printf("Done!\n\nGetting file size...");
	fstats *fs;
	ret = ISFS_GetFileStats(fd, fs);
	if (ret < 0) {
		printf(err, ret);
		return ret;
	}
	len = fs->file_length;
	printf("Preparing to copy...");
	buffer = memalign(32, len);
	printf("Copying...");
	ret = ISFS_Read(fd, buffer, len);
	if (ret < 0) {
		printf(err, ret);
		return ret;
	}
	ret = ISFS_Close(fd);
	if (ret < 0) {
		printf(err, ret);
		return ret;
	}
	printf("Done!\n\n");
	return 0;
}

void save_menu();
int remove_patch(patch_t *pt) {
	u8 *patch_addr;
	int test;
	patch_addr = buffer + pt->offset;
	if (memcmp(patch_addr, pt->new_tab, pt->size)) {
		printf("\x1b[2J\x1b[2;2HThe patch section was not found in the DOL. Nothing to do.\x1b[24;35HA: Continue.");
		test = 1;
			while (test) {
				WPAD_ScanPads();
				if (WPAD_ButtonsDown(0) & WPAD_BUTTON_A) test = 0;
			}
		return(-1);
	}
	printf("\x1b[2J\x1b[2;2HThe patch was found. Press A to remove.\x1b[24;28HA: Continue     B: Back");
	test = 1;
	while (test) {
		WPAD_ScanPads();
		switch (WPAD_ButtonsDown(0)) {
			case WPAD_BUTTON_A:
				test = 0;
				break;
			case WPAD_BUTTON_B:
				return -1;
				break;
		}
	}
	memcpy(patch_addr, pt->old_tab, pt->size);
	return 0;
}
int install_patch(patch_t *pt) {
	u8 *patch_addr;
	int test;
	patch_addr = buffer + pt->offset;
	if (memcmp(patch_addr, pt->old_tab, pt->size)) {
		printf("\x1b[2J\x1b[2;2HThe patch section was not found in the DOL. Nothing to do.\x1b[24;35HA: Continue.");
		test = 1;
			while (test) {
				WPAD_ScanPads();
				if (WPAD_ButtonsDown(0) & WPAD_BUTTON_A) test = 0;
			}
		return(-1);
	}
	printf("\x1b[2J\x1b[2;2HThe patch was found. Press A to apply.\x1b[24;28HA: Continue     B: Back");
	test = 1;
	while (test) {
		WPAD_ScanPads();
		switch (WPAD_ButtonsDown(0)) {
			case WPAD_BUTTON_A:
				test = 0;
				break;
			case WPAD_BUTTON_B:
				return -1;
				break;
		}
	}
	memcpy(patch_addr, pt->new_tab, pt->size);
	return 0;
}
void save_menu() {
	s32 fd;
	int test = 1;
	printf("\x1b[47m\x1b[30m\x1b[2J\x1b[2;2HNOW IS YOUR LAST CHANCE TO TURN BACK!\x1b[24;28HA: Continue     B: Back");
	while (test) {
		WPAD_ScanPads();
		switch (WPAD_ButtonsDown(0)) {
			case WPAD_BUTTON_A:
				test = 0;
				break;
			case WPAD_BUTTON_B:
				printf("\x1b[2J\x1b[2;2HReturning to loader...");
				exit(0);
				break;
		}
	}
	printf("\x1b[2J\x1b[2;2HISFS_Open...");
    fd = HEDE_OpenContentWRITE(index);
	if(fd ==NULL) {
		printf(err, fd);
	}
	printf("Done!\n\nWriting system menu...");
	ret = ISFS_Write(fd, buffer, len);
	if (ret < 0) {
		printf(err, ret);
	}
	ret = ISFS_Deinitialize();
	if (ret < 0) {
		printf(err, ret);
	}
	ret = __ES_Close();
	if (ret < 0) {
		printf(err, ret);
	}
	printf("Done! Returning to loader...");
	exit(0);
}

void ClearScreen()
{
	VIDEO_WaitVSync();
	console_init(xfb,20,20,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth*VI_DISPLAY_PIX_SZ);
	VIDEO_Configure(rmode);
	VIDEO_SetNextFramebuffer(xfb);
	VIDEO_SetBlack(FALSE);
	VIDEO_Flush();
	VIDEO_WaitVSync();
}

void reiniciar(void)
{
	printf("\n    Restarting Wii...");
	fflush(stdout);

		/* Return to the Wii system menu */
	SYS_ResetSystem(SYS_RETURNTOMENU, 0, 0);
}	

void Warning(void)
{
	/* Print Warning */
	printf("    [+] [ WARNING!!!]:\n\n");
	printf("    --------------------------------------------------\n\n");
    printf("    |   USE ONLY IN WIIS  AND SYSMENU 4.0 NTSC JAP, |\n");
	printf("    |   These patches are not temporary,             |\n");
	printf("    |   and can BRICK YOUR WII!.                     |\n");
	printf("    |   PLEASE BE CAREFUL WITH PATCHES.H!            |\n");
	printf("    --------------------------------------------------\n\n");
	printf("    --------------------------------------------------\n\n");
    printf("    |   Thanks crediar for PRELOADER                 |\n");
	printf("    |   Thanks Alejandroues for USA MOD              |\n");
	printf("    |   Thanks Wiicrazy for PATCH HEDE               |\n");
	printf("    --------------------------------------------------\n\n");
	printf("    >>   press A button to continue.\n");
	printf("    >>   press B button to restart your Wii.\n");

	/* Wait for user answer */
	for (;;) {
	WPAD_ScanPads();
		u32 buttonsDown = WPAD_ButtonsDown(0);;

		if (buttonsDown & WPAD_BUTTON_A)
			break;

		if (buttonsDown & WPAD_BUTTON_B)
			reiniciar();
	}
}

//---------------------------------------------------------------------------------
int main(int argc, char **argv) {
//---------------------------------------------------------------------------------

	DEBUG_Init(0, 1);

	// Initialise the video system
	VIDEO_Init();
	
	// This function initialises the attached controllers
	WPAD_Init();
	
	// Obtain the preferred video mode from the system
	// This will correspond to the settings in the Wii menu
	rmode = VIDEO_GetPreferredMode(NULL);

	// Allocate memory for the display in the uncached region
	xfb = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));
	
	// Initialise the console, required for printf
	console_init(xfb,20,20,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth*VI_DISPLAY_PIX_SZ);
	
	// Set up the video registers with the chosen mode
	VIDEO_Configure(rmode);
	
	// Tell the video hardware where our display memory is
	VIDEO_SetNextFramebuffer(xfb);
	
	// Make the display visible
	VIDEO_SetBlack(FALSE);

	// Flush the video register changes to the hardware
	VIDEO_Flush();

	// Wait for Video setup to complete
	VIDEO_WaitVSync();
	if(rmode->viTVMode&VI_NON_INTERLACE) VIDEO_WaitVSync();

	int i, init, install, option = 0;
	init = load_menu();
	if (init < 0) {
		printf("Returning to loader...");
		sleep(2);
		exit(0);
	}
	ClearScreen();
    Warning();
    // The console understands VT terminal escape codes
	// This positions the cursor on row 2, column 0
	// we can use variables for this with format codes too
	// e.g. printf ("\x1b[%d;%dH", row, column );
	printf("\x1b[2;0H");
	
	while(1) {

		printf("\x1b[40m\x1b[2J\x1b[2;22H\x1b[33mStartPatch V4.0.6 by Aquilino\n");
		int space = 25/(PATCH_COUNT+1), patch = 1;
		for (i = 0; i < PATCH_COUNT; i++) {
			printf("\x1b[%d;20HInstall Patch - %s", (space * i) + 4, ptch[i].desc);
		}
		printf("\x1b[%d;20HSave", (space * PATCH_COUNT) + 4);
		printf("\x1b[%d;20HExit", (space * PATCH_COUNT+1) + 4);
		printf("\x1b[%d;10HA : install  B : unistall  HOME : exit to loader", (space * PATCH_COUNT+5) + 4);
		printf("\x1b[%d;17H*", (space * option) + 4);
                 

		while(patch) {

			// Call WPAD_ScanPads each loop, this reads the latest controller states
			WPAD_ScanPads();

			// WPAD_ButtonsDown tells us which buttons were pressed in this loop
			// this is a "one shot" state which will not fire again until the button has been released
			if (WPAD_ButtonsDown(0) != 0) {
				printf("\x1b[%d;17H\x1b[30m*", (space * option) + 4);
				switch (WPAD_ButtonsDown(0)) {
					case WPAD_BUTTON_HOME:
						exit(0);
						break;
					case WPAD_BUTTON_UP:
						option--;
						if (option < 0) option = PATCH_COUNT+1;
						break;
					case WPAD_BUTTON_DOWN:
						option++;
						if (option > PATCH_COUNT+1) option = 0;
						break;
					case WPAD_BUTTON_A:
						if (option == PATCH_COUNT+1) exit(0);
						if (option == PATCH_COUNT) save_menu();
						printf("\x1b[32m\x1b[2J\x1b[2;2H");
						install = install_patch(&ptch[option]);
						patch = 0;
						break;
					case WPAD_BUTTON_B:
						if (option == PATCH_COUNT+1) exit(0);
						if (option == PATCH_COUNT) save_menu();
						printf("\x1b[32m\x1b[2J\x1b[2;2H");
						install = remove_patch(&ptch[option]);
						patch = 0;
						break;
				}
				printf("\x1b[%d;17H\x1b[32m*", (space * option) + 4);
			}
			VIDEO_WaitVSync();
		}
	}
	return 0;
}
